﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CPF_experement
{
    /// <summary>
    /// This class represents a state in the A* search with operator decomposition, as proposed by Trevor Scott Standley's AAAI paper in 2010.
    /// More specifically, states can represent a partial move, in which only some of the agents has moved
    /// and the other have not yet moved in this turn. 
    /// </summary>
    public class WorldStateFocal : WorldState
    {
        public WorldState orgnl;


        public WorldStateFocal(WorldState cpy)
            : base(cpy.allAgentsState)
        {
            this.g = cpy.g;
            this.h = cpy.h;
            orgnl = cpy;
        }

        public override int CompareTo(IBinaryHeapItem other)
        {
            WorldState that = (WorldState)other;
            if (this.h < that.h)
                return -1;
            if (this.h > that.h)
                return 1;
            return 0;
        }

    }
}
